#ifndef __AADL_DISPATCH_H__
#define __AADL_DISPATCH_H__

#ifdef USE_MACH
#include <mach/clock.h>
#include <mach/mach.h>
#include <sys/time.h>
#endif

#include "aadl_runtime_services.h"

#ifdef USE_POSIX
int create_thread (unsigned int priority,
		   unsigned int stack_size,
		   void (*start_routine)(void),
		   pthread_t * tid,
		   int policy,
		   unsigned int core_id);
#endif

// To keep in private
//int init_periodic_config (periodic_thread_config_t * config);
//int init_sporadic_config (sporadic_thread_config_t * config);

StatusType Stop_Thread(thread_config_t * config);
StatusType Start_Thread(thread_config_t * config);
StatusType Create_Thread(thread_config_t * config);

int Init_Config (thread_config_t * config,
		 error_code_t (*recovery_entrypoint)(thread_config_t * config, error_code_t error),
		 void * (*compute_entrypoint)(),
		 unsigned int id);

void wait_next_period (thread_config_t *config);

int mask_realtime_signals();

// To keep in private
//StatusType await_periodic_dispatch(periodic_thread_config_t * global_q);
//StatusType await_sporadic_dispatch(sporadic_thread_config_t * global_q);

unsigned long get_start_time_ns();

StatusType keep_busy_until(unsigned int finish_time_ns);

int init_thread_config(thread_config_t * config);
int init_sporadic_config (sporadic_thread_config_t * info);
int init_aperiodic_config (aperiodic_thread_config_t * info);
int init_periodic_config (periodic_thread_config_t * info);
int init_hybrid_config (hybrid_thread_config_t * info);
int init_timed_config (timed_thread_config_t * info);

#endif
