#include "aadl_error.h"
#include "aadl_ports.h"

thread_config_t faulty_thread;
error_code_t global_error;

error_code_t Error_Handler(error_code_t error,
                   thread_config_t * config,
                   port_reference_t * error_port)
{

 error_code_t (*recover_entrypoint)(thread_config_t * config, error_code_t error) = config->recovery_entrypoint;
  error_code_t recover_res = error;
  if(recover_entrypoint != NULL)
    recover_res = (*recover_entrypoint)(config, error);
  if (recover_res != OK)
  {
    if (error_port != NULL) // FIXME later with port connections
    {
      StatusType res = Put_Value(error_port, &recover_res);
      res = Send_Output(error_port);
      if (res != 0)
      {
        global_error = recover_res;
        Raise_Error (recover_res);
      }

      res = Send_Output(error_port);
      if (res != 0)
      {
        global_error = recover_res;
        Raise_Error (recover_res);
      }
    }
    else
    {
      global_error = error;
      Raise_Error (error);
    }
  }
  return recover_res;
}

void Raise_Error (error_code_t error)
{
	global_error = error;
	return;
}

error_code_t Get_Error_Code()
{
  return global_error;
}
