#ifndef AADL_PORTS_H
#define AADL_PORTS_H

#include "aadl_runtime_services.h"
#include "aadl_error.h"
#include "aadl_modes_standard.h"
#include "aadl_multiarch.h"

#ifdef USE_POSIX

#ifdef DEBUG
#include <stdio.h>
#endif // DEBUG
#endif // USE_POSIX


// Variants of standard calls
StatusType Do_Send_Output_Data_Thread(thread_config_t * thread);
StatusType Do_Send_Output(port_reference_t * src_port);

StatusType Send_Output_Destination(port_connection_t * connection);
StatusType Send_Output_Inter_Thread(port_connection_t * connection);
StatusType Send_Output_Inter_Thread_Fifo(port_connection_t * connection);
StatusType Send_Output_Inter_Thread_Sampled(port_connection_t * connection);
StatusType Send_Output_Inter_Thread_PDP_LowET(port_connection_t * connection);
StatusType Send_Output_Inter_Thread_PDP_LowMFP(port_connection_t * connection);

StatusType Send_Output_Inter_Process(port_connection_t * connection);

StatusType Receive_Input_Source(port_connection_t * connection);
StatusType Receive_Input_Inter_Thread(port_connection_t * connection);
StatusType Receive_Input_Inter_Thread_Fifo(port_connection_t * connection);
StatusType Receive_Input_Inter_Thread_Sampled(port_connection_t * connection);
StatusType Receive_Input_Inter_Thread_PDP_LowET(port_connection_t * connection);

StatusType Receive_Input_Inter_Process(port_connection_t * connection);


// operations on all ports of a thread
StatusType Send_Output_Thread(thread_config_t * thread);
StatusType Receive_Input_Thread(thread_config_t * thread);

#endif //AADL_PORTS_H
