#include "aadl_multiarch.h"

int init_thread_config_multiarch(thread_config_t * config)
{
  return -1; // init wait_mode_rez and wait_mode_event
}

int init_periodic_config_multiarch(periodic_thread_config_t * info)
{
  int ret;
  ret = pthread_mutex_init(info->time_interval_mutex, NULL);
  pthread_cond_init(info->time_interval_cond, NULL);
  static char is_init=0;
  if(!is_init)
  {
    struct timeval tv;
    struct timespec ts;
    gettimeofday(&tv, NULL);
    start_timespec->tv_sec = tv.tv_sec;
    start_timespec->tv_nsec = 0;
  }
  return ret;
}

StatusType Await_Mode_multiarch(thread_config_t * config)
{
  return 0;
}

StatusType await_periodic_dispatch_multiarch(periodic_thread_config_t * info)
{
  StatusType ret = E_OK;
  struct timespec periodic_timespec;
  unsigned long msec = info->period;
  unsigned long ns = (info->period*1000 - (msec * 1000)) * 1000;
  info->iteration_counter++;

  int periodic_sec = start_timespec.tv_sec+ info->iteration_counter*msec/1000;
  int periodic_nsec = start_timespec.tv_nsec+ info->iteration_counter*ns;

  while(periodic_nsec >= 1000000000) {
    periodic_nsec -= 1000000000;
    periodic_sec++;
  }
  
  while(periodic_nsec < 0) {
    periodic_nsec += 1000000000;
    periodic_sec--;
  }

  periodic_timespec.tv_sec = periodic_sec;
  periodic_timespec.tv_nsec = periodic_nsec;

  
  cancel_wd(&info->wd); 
  slret=clock_nanosleep(CLOCK_MONOTONIC, TIMER_ABSTIME, &periodic_timespec, NULL);
  return ret;
}

//void set_wait_time(sporadic_thread_config_t * info)
//{
//  struct timespec sporadic_time_interval;
//  unsigned long sec = info->time_interval/1000;
//  unsigned long ns = (info->time_interval*1000 - (sec * 1000000)) * 1000;
//
//  clock_serv_t cclock;
//  mach_timespec_t mts;
//  host_get_clock_service(mach_host_self(), CALENDAR_CLOCK, &cclock);
//  clock_get_time(cclock, &mts);
//  mach_port_deallocate(mach_task_self(), cclock);
//  sporadic_time_interval.tv_sec = mts.tv_sec;
//  sporadic_time_interval.tv_nsec = mts.tv_nsec;
//
//  info->sporadic_timespec->tv_sec = sporadic_time_interval.tv_sec+sec;
//  info->sporadic_timespec->tv_nsec = sporadic_time_interval.tv_nsec+ns;
//}
