#include "aadl_multiarch.h"

int init_thread_config_multiarch(thread_config_t * config)
{
  return 0; // nothing to do
}

int init_periodic_config_multiarch(periodic_thread_config_t * info)
{
  return 0;
}

StatusType Await_Mode_multiarch(thread_config_t * config)
{
  return 0;
}

StatusType await_periodic_dispatch_multiarch(periodic_thread_config_t * info)
{
  StatusType ret = E_OK;// dispatch in osek can be managed by the periodic alarm, so doesn't need C code
  TerminateTask();
  return ret;
}

int is_period_passed(hybrid_thread_config_t * info)
{
  return 0;
}

void sporadic_thread_sleep(sporadic_thread_config_t * info)
{
  int msec = info->time_interval;
  AlarmType time_interval_alrm;
  SetRelAlarm(&time_interval_alrm, msec, 0);
  info->timing_wait_phase = 0;
  TerminateTask();
}

StatusType init_hybrid_timer(hybrid_thread_config_t * info)
{
  int msec = info->time_interval/1000000000;
  StatusType status = SetRelAlarm(info->time_interval_alarm, msec, 0);
  return status;
}

StatusType hybrid_reset_timer(hybrid_thread_config_t * info)
{
  return E_OK; // this is managed by the cyclic alarm
}

StatusType timedwait_hybrid(hybrid_thread_config_t * info)
{
  StatusType status = wait_port_list(info->parent->global_q);
  return status;
}

StatusType timedwait_timed_thread(timed_thread_config_t * info)
{
  AlarmType time_out_alarm;
  int msec = info->time_interval;
  StatusType status = SetRelAlarm(time_out_alarm, msec, 0);
  status = wait_port_list(info->parent->global_q);
  CancelAlarm(time_out_alarm);
  return status;
}

extern unsigned long osek_absolute_time_ms;
void get_time_multiarch(runtime_time_t * time)
{
	time->msec = osek_absolute_time_ms;
	time->nsec = 0;
}

void get_start_time(runtime_time_t * time)
{
	time->msec = 0;
	time->nsec = 0;
}

void set_start_time_multiarch()
{
  return;
}
